<?php

namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\SM\Util\Utilities;
use Teknisa\SM\Service\Sm00005000ParametrizacoesServicesService;

class FctContratoGridAgrupamentoController extends SMCrud {
    
    protected $dataSourceName = "fct_contrato_grid_agrupamento";
    protected $parametrogeral;
    
    public function __construct($crudService, $environment, Sm00005000ParametrizacoesServicesService $parametrogeral) {
        parent::__construct($crudService, $environment);
        $this->parametrogeral = $parametrogeral;
    }

    public function find(Request\Filter $request, Response $response) {
        try {
            $idUtilizaOper = $this->parametrogeral->getIdUtilizaHierarquiaOper($this->environment->getNrorg());
            if($idUtilizaOper == "S") {
                $this->dataSourceName = "fct_contrato_grid_hierarquia_agrupamento";
                $request->getFilterCriteria()->addCondition("CDOPERADOR", "=", $this->environment->getCdOperador());
            }
            
            parent::find($request, $response);
            $erro = $response->getError();
            if ($erro) {
                throw new \Exception($erro->getMessage(), $erro->getErrorCode());
            }
                
            $rows = $response->getDataSets()[0]->getRows();
            
            $this->dataSourceName = "fct_contrato_grid_agrupamento";
            $response->setDataSets(array(new DataSet($this->dataSourceName, $rows)));
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}

?>