/*
Criao: 23/05/2012
Responsvel: Welbert Moitinha
Descrio: Gera o histrico de alteraes feitas na tabela PARFILIALFAT
*/


IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_FAI_PARFILIALFAT' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)

DROP TRIGGER LOG_FAI_PARFILIALFAT
GO


CREATE TRIGGER LOG_FAI_PARFILIALFAT
ON PARFILIALFAT
FOR UPDATE,INSERT, DELETE
AS
BEGIN

   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DESC         VARCHAR(400);
   DECLARE @V_ITPESQ       VARCHAR(40);
   DECLARE @V_NMOPERADOR   VARCHAR(40);
   DECLARE @V_IDTIPOOPER   VARCHAR(1);


   DECLARE @V_CDFILIAL_OLD       VARCHAR(4);
   DECLARE @V_VRPERECUPIMP_OLD   DOUBLE PRECISION;
   DECLARE @V_NRFUNCFATUR_OLD    VARCHAR(5);
   DECLARE @V_IDMRCONSCGO_OLD    VARCHAR(1);
   DECLARE @V_IDEFECONSCGO_OLD   VARCHAR(1);
   DECLARE @V_VRPECREDICMFAT_OLD DOUBLE PRECISION;

   DECLARE @V_CDFILIAL_NEW       VARCHAR(4);
   DECLARE @V_VRPERECUPIMP_NEW   DOUBLE PRECISION;
   DECLARE @V_NRFUNCFATUR_NEW    VARCHAR(5);
   DECLARE @V_IDMRCONSCGO_NEW    VARCHAR(1);
   DECLARE @V_IDEFECONSCGO_NEW   VARCHAR(1);
   DECLARE @V_VRPECREDICMFAT_NEW DOUBLE PRECISION;
   DECLARE @V_ID_COMANDO VARCHAR(1);
   DECLARE @V_TIPO VARCHAR(1);
   DECLARE @V_DTOPER DATETIME;

/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';



   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;


   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         CDFILIAL,
         VRPERECUPIMP,
         NRFUNCFATUR,
         IDMRCONSCGO,
         IDEFECONSCGO,
         VRPECREDICMFAT
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
         INSERTED.CDFILIAL,
         INSERTED.VRPERECUPIMP,
         INSERTED.NRFUNCFATUR,
         INSERTED.IDMRCONSCGO,
         INSERTED.IDEFECONSCGO,
         INSERTED.VRPECREDICMFAT,
         DELETED.CDFILIAL,
         DELETED.VRPERECUPIMP,
         DELETED.NRFUNCFATUR,
         DELETED.IDMRCONSCGO,
         DELETED.IDEFECONSCGO,
         DELETED.VRPECREDICMFAT
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDFILIAL  = DELETED.CDFILIAL


      UNION ALL

      SELECT
         'I' IDCOMANDO,

         INSERTED.CDFILIAL,
         INSERTED.VRPERECUPIMP,
         INSERTED.NRFUNCFATUR,
         INSERTED.IDMRCONSCGO,
         INSERTED.IDEFECONSCGO,
         INSERTED.VRPECREDICMFAT,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDFILIAL_NEW,
                                 @V_VRPERECUPIMP_NEW,
                                 @V_NRFUNCFATUR_NEW,
                                 @V_IDMRCONSCGO_NEW,
                                 @V_IDEFECONSCGO_NEW,
                                 @V_VRPECREDICMFAT_NEW,
                                 @V_CDFILIAL_OLD,
                                 @V_VRPERECUPIMP_OLD,
                                 @V_NRFUNCFATUR_OLD,
                                 @V_IDMRCONSCGO_OLD,
                                 @V_IDEFECONSCGO_OLD,
                                 @V_VRPECREDICMFAT_OLD;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF NOT @V_NMOPERADOR IS NULL BEGIN
         IF @V_ID_COMANDO = 'D'  BEGIN
            SET @V_TIPO = '3';
            SET @V_ITPESQ = @V_CDFILIAL_OLD;
            SET @V_DESC   = 'Filial '    + @V_CDFILIAL_OLD + ' '+
                            'Percentual de Imposto: '+ CONVERT(VARCHAR, @V_VRPERECUPIMP_OLD)+
                            'Num. Funcionarios a faturar: '+ @V_NRFUNCFATUR_OLD+
                            'Util. Mquina registradora no CGO: '+ @V_IDMRCONSCGO_OLD+
                            'Util. efetivos no CGO: '+ @V_IDEFECONSCGO_OLD+
                            'Vr. Percentual de crdito de ICMS: '+ CONVERT( VARCHAR, @V_VRPECREDICMFAT_OLD);
         END
         ELSE BEGIN
            IF @V_ID_COMANDO = 'U' BEGIN
               SET @V_ITPESQ = @V_CDFILIAL_OLD;
               SET @V_DESC = 'Filial '    + @V_CDFILIAL_OLD + ' ';

               SET @V_DESC = @V_DESC + ' Alterado:';
               SET @V_TIPO = '2';

               IF(@V_VRPERECUPIMP_OLD <> @V_VRPERECUPIMP_NEW) BEGIN
                  SET @V_DESC = @V_DESC + 'Percentual de Imposto: '+ CONVERT(VARCHAR, @V_VRPERECUPIMP_OLD);
               END;

               IF(@V_NRFUNCFATUR_OLD <> @V_NRFUNCFATUR_NEW) BEGIN
                  SET @V_DESC = @V_DESC + 'Num. Funcionarios a faturar: ' + @V_NRFUNCFATUR_OLD;
               END;

               IF(@V_IDMRCONSCGO_OLD <> @V_IDMRCONSCGO_NEW)BEGIN
                  SET @V_DESC = @V_DESC + 'Util. Mquina registradora no CGO: ' + @V_IDMRCONSCGO_OLD;
               END;

               IF(@V_IDEFECONSCGO_OLD <> @V_IDEFECONSCGO_NEW)BEGIN
                  SET @V_DESC = @V_DESC + 'Util. efetivos no CGO: '+ @V_IDEFECONSCGO_OLD;
               END;

               IF(@V_VRPECREDICMFAT_OLD <> @V_VRPECREDICMFAT_NEW) BEGIN
                  SET @V_DESC = @V_DESC + 'Vr. Percentual de crdito de ICMS: '+ CONVERT(VARCHAR,@V_VRPECREDICMFAT_OLD);
               END;
            END
            ELSE BEGIN
               SET @V_TIPO   = '1';
               SET @V_DESC   = 'Filial '    + @V_CDFILIAL_NEW + ' '+
                            'Percentual de Imposto: '+ CONVERT(VARCHAR, @V_VRPERECUPIMP_NEW)+
                            'Num. Funcionarios a faturar: '+ @V_NRFUNCFATUR_NEW+
                            'Util. Mquina registradora no CGO: '+ @V_IDMRCONSCGO_NEW+
                            'Util. efetivos no CGO: '+ @V_IDEFECONSCGO_NEW+
                            'Vr. Percentual de crdito de ICMS: '+ CONVERT( VARCHAR, @V_VRPECREDICMFAT_NEW);

               SET @V_ITPESQ = @V_CDFILIAL_NEW;
            END;
         END;

         IF @V_TIPO <> '0' BEGIN
            IF NOT @V_DESC IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               SET @V_DESC = SUBSTRING(ISNULL(@V_DESC, ' '), 1, 300);

               INSERT INTO LOGOPERA(NMTABELA, DTOPERACAO, NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO,  CDPESQITEM)
                     VALUES   ('PARFILIALFAT', GETDATE() , @V_NMOPERADOR,
                               @V_TIPO,   @V_DESC, ISNULL(@V_ITPESQ, ' '));


            END;
         END;
      END;

      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDFILIAL_NEW,
                                 @V_VRPERECUPIMP_NEW,
                                 @V_NRFUNCFATUR_NEW,
                                 @V_IDMRCONSCGO_NEW,
                                 @V_IDEFECONSCGO_NEW,
                                 @V_VRPECREDICMFAT_NEW,
                                 @V_CDFILIAL_OLD,
                                 @V_VRPERECUPIMP_OLD,
                                 @V_NRFUNCFATUR_OLD,
                                 @V_IDMRCONSCGO_OLD,
                                 @V_IDEFECONSCGO_OLD,
                                 @V_VRPECREDICMFAT_OLD;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_FAI_PARFILIALFAT','5.20.000';
GO
